<!DOCTYPE html>
<html>
  <head>
    <title>Operaciones CSG</title>
    <style>
      html, body { margin: 0; padding: 0; overflow: hidden; }
    </style>
  </head>
  <body>
    <script src="js/three.js"></script>
	<script src="js/controls/OrbitControls.js"></script>
	<script src="js/csg.js"></script>
	<script src="js/THREE.CSG.js"></script>
    <script>
		var scene, aspect, camera, renderer, controls;
		init();
		animate();
		function init(){
			//INICIALIZACIÓN
	        scene = new THREE.Scene();
	        aspect = window.innerWidth / window.innerHeight;
	        camera = new THREE.PerspectiveCamera( 75, aspect, 0.1, 1000);
	        renderer = new THREE.WebGLRenderer();
	        renderer.setSize( window.innerWidth, window.innerHeight );
	        document.body.appendChild( renderer.domElement );
			controls = new THREE.OrbitControls( camera, renderer.domElement );
			
			//ELEMENTOS COMUNES
			var size = 10;
			var arrowSize = 1;
			var divisions = size;
			var origin = new THREE.Vector3( 0, 0, 0 );
			var x = new THREE.Vector3( 1, 0, 0 );
			var y = new THREE.Vector3( 0, 1, 0 );
		  	var z = new THREE.Vector3( 0, 0, 1 );
		  	var color = new THREE.Color( 0x333333 );
		  	var colorR = new THREE.Color( 0xAA3333 );
		  	var colorG = new THREE.Color( 0x33AA33 );
		  	var colorB = new THREE.Color( 0x333366 );
			
		  	//CREAR LAS GRILLAS PARA EL ESCENARIO
		  	var axesHelper = new THREE.AxesHelper( size );
			scene.add( axesHelper );
			
		  	var gridHelperXZ = new THREE.GridHelper( size, divisions, color, color );
			scene.add( gridHelperXZ );
            
            //ROTARLAS PARA QUE QUEDEN EN EL ESPACIO ADECUADO
            gridHelperXZ.rotateOnWorldAxis ( y, THREE.Math.degToRad(90) );

            //CREAR ILUMINACIÓN
            var ambient = new THREE.AmbientLight( 0xffffff, 2 );
            scene.add( ambient );
			
            var pointLight = new THREE.PointLight( 0xffffff, 1, 100 );
            pointLight.position.set( -5, -2, 5 );
            scene.add( pointLight );
			
            var pointLight = new THREE.PointLight( 0xffffff, .5, 100 );
            pointLight.position.set( 5, -2, -5 );
            scene.add( pointLight );
			
			//CREAR LAS GEOMETRÍAS
			var boxGeometry = new THREE.BoxGeometry( 1, 1, 1 );
			var sphereGeometry = new THREE.SphereGeometry( .5, 32, 32 );
			var toroide = new THREE.TorusGeometry( 0.25, 0.05, 16, 100 );
			var toroide2 = new THREE.TorusGeometry( 0.25, 0.05, 16, 100);
			
			//CREAR LOS MATERIALES
            var material1 = new THREE.MeshStandardMaterial( { color: colorR, metalness: 0.5, roughness: 0.1 } );
			var material2 = new THREE.MeshStandardMaterial( { color: colorG, metalness: 0.5, roughness: 0.1, transparent:true, opacity: 0.5  } );
			
			//CREAR LAS MALLAS
			var cube = new THREE.Mesh( boxGeometry );
			var sphere = new THREE.Mesh( sphereGeometry );
			var toro= new THREE.Mesh( toroide );
		    toro.rotation.x=Math.PI / 2
			toro.position.x=-0.25;
			var toro2= new THREE.Mesh( toroide2 );
			cube.translateY( .5 );
			//sphere.translateY( .5 );
			//sphere.translateZ( .5 );
			
			//CONVERTIR A CSG
			var boxCSG = THREE.CSG.fromMesh( cube );
			var sphereCSG = THREE.CSG.fromMesh( sphere );
			var toroCSG = THREE.CSG.fromMesh( toro);
			var toro2CSG = THREE.CSG.fromMesh( toro2);
			//APLICAR LAS OPERACIONES
			var result1 = boxCSG.subtract( sphereCSG );	//CAJA MENOS ESFERA
			var result2= boxCSG.intersect( sphereCSG );	//INTERSECCIÓN - CAJA Y ESFERA
			var result3 = boxCSG.union( sphereCSG );	//UNIÓN - CAJA Y ESFERA0
			var resultA = toroCSG.union( toro2CSG );	//UNIÓN - CAJA Y ESFERA0
			var resultB = sphereCSG.subtract( boxCSG );	//ESFEra MENOSRA M CAJA
			//CONVERTIR A MALLA DE THREE JS NUEVAMENTE
			var C2T1 = THREE.CSG.toMesh( result1 );
			var C2T2 = THREE.CSG.toMesh( result2 );
			var C2T3 = THREE.CSG.toMesh( result3 );
			var C2TB = THREE.CSG.toMesh( resultB );
			var C2TA = THREE.CSG.toMesh( resultA );
			
			C2T1.material = material1; 
			C2T2.material = material1; 
			C2T3.material = material1; 
			C2TB.material = material1; 
			C2TA.material = material1; 
			
			cube.material = material1;
			sphere.material = material2;
			toro.material = material1;
			toro2.material = material1;
			
			C2T1.translateX(2);
			C2T2.translateX(-2);
			C2T3.translateZ(2);
			C2TB.translateZ(-2);
			C2TA.translateZ(-2);
			
			var f = THREE.CSG.fromMesh( C2TA );
			var f2 = THREE.CSG.fromMesh( C2TB);
			var resultC = f2.subtract( f );	//ESFEra MENOS anillos
			var C2TF = THREE.CSG.toMesh( resultC );
			C2TF.material = material1; 
			C2TF.translateZ(-2);
			//AGREGAR A LA ESCENA LOS DIFERENTES ELEMENTOS
			scene.add( cube );			//ACTIVAR PARA VISUALIZAR EL CUBO
			scene.add( C2T1 );
			scene.add( C2T2 );
			scene.add( C2T3 );
			scene.add( C2TB );
			scene.add( C2TA );
			scene.add(C2TF);
			scene.add( sphere );		//ACTIVAR PARA VISUALIZAR LA ESFERA
			camera.position.x = 2;
			camera.position.y = 2;
		  	camera.position.z = 5;
			camera.lookAt( origin );
		}
		function animate(){
			requestAnimationFrame( animate );
			controls.update();
			render();
		}
		function render(){
			renderer.render( scene, camera );
		}
    </script>
  </body>
</html>
